/**********************************************************************
* IBM Confidential
* 
* OCO Source Materials
* 
* IBM Cognos Products: TM1 Server
* 
* (C) Copyright IBM Corp. 2016
* 
* The source code for this program is not published or otherwise divested
* of its trade secrets, irrespective of what has been deposited with the
* U.S. Copyright Office.
**********************************************************************/

/*
 * Generated on 6/2/16 10:38 PM
 */
package com.ibm.cognos.TurboDebugger;

import java.io.*;
import javax.swing.text.Segment;

import org.fife.ui.rsyntaxtextarea.*;


/**
 * 
 */
%%

%public
%class TurboIntegratorSyntaxStyle
%extends AbstractJFlexTokenMaker
%unicode
%ignorecase
%type org.fife.ui.rsyntaxtextarea.Token


%{


	/**
	 * Constructor.  This must be here because JFlex does not generate a
	 * no-parameter constructor.
	 */
	public TurboIntegratorSyntaxStyle() {
	}


	/**
	 * Adds the token specified to the current linked list of tokens.
	 *
	 * @param tokenType The token's type.
	 * @see #addToken(int, int, int)
	 */
	private void addHyperlinkToken(int start, int end, int tokenType) {
		int so = start + offsetShift;
		addToken(zzBuffer, start,end, tokenType, so, true);
	}


	/**
	 * Adds the token specified to the current linked list of tokens.
	 *
	 * @param tokenType The token's type.
	 */
	private void addToken(int tokenType) {
		addToken(zzStartRead, zzMarkedPos-1, tokenType);
	}


	/**
	 * Adds the token specified to the current linked list of tokens.
	 *
	 * @param tokenType The token's type.
	 * @see #addHyperlinkToken(int, int, int)
	 */
	private void addToken(int start, int end, int tokenType) {
		int so = start + offsetShift;
		addToken(zzBuffer, start,end, tokenType, so, false);
	}


	/**
	 * Adds the token specified to the current linked list of tokens.
	 *
	 * @param array The character array.
	 * @param start The starting offset in the array.
	 * @param end The ending offset in the array.
	 * @param tokenType The token's type.
	 * @param startOffset The offset in the document at which this token
	 *        occurs.
	 * @param hyperlink Whether this token is a hyperlink.
	 */
	public void addToken(char[] array, int start, int end, int tokenType,
						int startOffset, boolean hyperlink) {
		super.addToken(array, start,end, tokenType, startOffset, hyperlink);
		zzStartRead = zzMarkedPos;
	}


	/**
	 * {@inheritDoc}
	 */
	public String[] getLineCommentStartAndEnd(int languageIndex) {
		return new String[] { "#", null };
	}


	/**
	 * Returns the first token in the linked list of tokens generated
	 * from <code>text</code>.  This method must be implemented by
	 * subclasses so they can correctly implement syntax highlighting.
	 *
	 * @param text The text from which to get tokens.
	 * @param initialTokenType The token type we should start with.
	 * @param startOffset The offset into the document at which
	 *        <code>text</code> starts.
	 * @return The first <code>Token</code> in a linked list representing
	 *         the syntax highlighted text.
	 */
	public Token getTokenList(Segment text, int initialTokenType, int startOffset) {

		resetTokenList();
		this.offsetShift = -text.offset + startOffset;

		// Start off in the proper state.
		int state = Token.NULL;
		switch (initialTokenType) {
			/* No multi-line comments */
			/* No documentation comments */
			default:
				state = Token.NULL;
		}

		s = text;
		try {
			yyreset(zzReader);
			yybegin(state);
			return yylex();
		} catch (IOException ioe) {
			ioe.printStackTrace();
			return new TokenImpl();
		}

	}


	/**
	 * Refills the input buffer.
	 *
	 * @return      <code>true</code> if EOF was reached, otherwise
	 *              <code>false</code>.
	 */
	private boolean zzRefill() {
		return zzCurrentPos>=s.offset+s.count;
	}


	/**
	 * Resets the scanner to read from a new input stream.
	 * Does not close the old reader.
	 *
	 * All internal variables are reset, the old input stream 
	 * <b>cannot</b> be reused (internal buffer is discarded and lost).
	 * Lexical state is set to <tt>YY_INITIAL</tt>.
	 *
	 * @param reader   the new input stream 
	 */
	public final void yyreset(Reader reader) {
		// 's' has been updated.
		zzBuffer = s.array;
		/*
		 * We replaced the line below with the two below it because zzRefill
		 * no longer "refills" the buffer (since the way we do it, it's always
		 * "full" the first time through, since it points to the segment's
		 * array).  So, we assign zzEndRead here.
		 */
		//zzStartRead = zzEndRead = s.offset;
		zzStartRead = s.offset;
		zzEndRead = zzStartRead + s.count - 1;
		zzCurrentPos = zzMarkedPos = zzPushbackPos = s.offset;
		zzLexicalState = YYINITIAL;
		zzReader = reader;
		zzAtBOL  = true;
		zzAtEOF  = false;
	}


%}

Letter							= [A-Za-z]
LetterOrUnderscore				= ({Letter}|"_")
NonzeroDigit						= [1-9]
Digit							= ("0"|{NonzeroDigit})
HexDigit							= ({Digit}|[A-Fa-f])
OctalDigit						= ([0-7])
AnyCharacterButApostropheOrBackSlash	= ([^\\'])
AnyCharacterButDoubleQuoteOrBackSlash	= ([^\\\"\n])
EscapedSourceCharacter				= ("u"{HexDigit}{HexDigit}{HexDigit}{HexDigit})
Escape							= ("\\"(([btnfr\"'\\])|([0123]{OctalDigit}?{OctalDigit}?)|({OctalDigit}{OctalDigit}?)|{EscapedSourceCharacter}))
NonSeparator						= ([^\t\f\r\n\ \(\)\{\}\[\]\;\,\.\=\>\<\!\~\?\:\+\-\*\/\&\|\^\%\"\']|"#"|"\\")
IdentifierStart					= ({LetterOrUnderscore}|"$")
IdentifierPart						= ({IdentifierStart}|{Digit}|("\\"{EscapedSourceCharacter}))

LineTerminator				= (\n)
WhiteSpace				= ([ \t\f]+)

CharLiteral	= ([\']({AnyCharacterButApostropheOrBackSlash}|{Escape})*[\'])
UnclosedCharLiteral			= ([\'][^\'\n]*)
ErrorCharLiteral			= ({UnclosedCharLiteral}[\'])
/* No string literals */

/* No multi-line comments */
/* No documentation comments */
LineCommentBegin			= "#"

IntegerLiteral			= ({Digit}+)
/* No hex literals */
FloatLiteral			= (({Digit}+)("."{Digit}+)?(e[+-]?{Digit}+)? | ({Digit}+)?("."{Digit}+)(e[+-]?{Digit}+)?)
ErrorNumberFormat			= (({IntegerLiteral}|{FloatLiteral}){NonSeparator}+)


Separator					= ([\(\)\{\}\[\]])
Separator2				= ([\;,.])

Identifier				= ({IdentifierStart}{IdentifierPart}*)

URLGenDelim				= ([:\/\?#\[\]@])
URLSubDelim				= ([\!\$&'\(\)\*\+,;=])
URLUnreserved			= ({LetterOrUnderscore}|{Digit}|[\-\.\~])
URLCharacter			= ({URLGenDelim}|{URLSubDelim}|{URLUnreserved}|[%])
URLCharacters			= ({URLCharacter}*)
URLEndCharacter			= ([\/\$]|{Letter}|{Digit})
URL						= (((https?|f(tp|ile))"://"|"www.")({URLCharacters}{URLEndCharacter})?)


/* No string state */
/* No char state */
/* No MLC state */
/* No documentation comment state */
%state EOL_COMMENT

%%

<YYINITIAL> {

	/* Keywords */
	"break" |
"else" |
"elseif" |
"end" |
"endif" |
"if" |
"while"		{ addToken(Token.RESERVED_WORD); }

	/* Keywords 2 (just an optional set of keywords colored differently) */
	"DATAMINORERRORCOUNT" |
"DATASOURCEASCIIDECIMALSEPARATOR" |
"DATASOURCEASCIIDELIMITER" |
"DATASOURCEASCIIHEADERRECORDS" |
"DATASOURCEASCIIQUOTECHARACTER" |
"DATASOURCEASCIITHOUSANDSEPARATOR" |
"DATASOURCECUBEVIEW" |
"DATASOURCEDIMENSIONSUBSET" |
"DATASOURCENAMEFORCLIENT" |
"DATASOURCENAMEFORSERVER" |
"DATASOURCEODBOCATALOG" |
"DATASOURCEODBOCONNECTIONSTRING" |
"DATASOURCEODBOCUBENAME" |
"DATASOURCEODBOHIERARCHYNAME" |
"DATASOURCEODBOLOCATION" |
"DATASOURCEODBOPROVIDER" |
"DATASOURCEODBOSAPCLIENTID" |
"DATASOURCEODBOSAPCLIENTLANGUAGE" |
"DATASOURCEPASSWORD" |
"DATASOURCEQUERY" |
"DATASOURCESAPUSINGROLEAUTHS" |
"DATASOURCESAPUSINGTEXTS" |
"DATASOURCETYPE" |
"DATASOURCEUSERNAME" |
"DataMinorErrorCount" |
"DataSourceASCIIDelimiter" |
"DataSourceASCIIHeaderRecords" |
"DataSourceASCIIQuoteCharacter" |
"DataSourceASCIIThousandSeparator" |
"DataSourceAsciiDecimalSeparator" |
"DataSourceCubeView" |
"DataSourceDimensionSubset" |
"DataSourceNameForClient" |
"DataSourceNameForServer" |
"DataSourceODBOCatalog" |
"DataSourceODBOConnectionString" |
"DataSourceODBOCubeName" |
"DataSourceODBOHierarchyName" |
"DataSourceODBOLocation" |
"DataSourceODBOProvider" |
"DataSourceODBOSAPClientID" |
"DataSourceODBOSAPClientLanguage" |
"DataSourcePassword" |
"DataSourceQuery" |
"DataSourceSAPUsingRoleAuths" |
"DataSourceSAPUsingTexts" |
"DataSourceType" |
"DataSourceUserName" |
"GETPROCESSERRORFILEDIRECTORY" |
"GETPROCESSERRORFILENAME" |
"GetProcessErrorFileDirectory" |
"GetProcessErrorFilename" |
"Index" |
"METADATAMINORERRORCOUNT" |
"MINORERRORLOGMAX" |
"MetaDataMinorErrorCount" |
"MinorErrorLogMax" |
"NUMERICGLOBALVARIABLE" |
"NUMERICSESSIONVARIABLE" |
"NVALUE" |
"NValue" |
"NumericGlobalVariable" |
"NumericSessionVariable" |
"ONMINORERRORDOITEMSKIP" |
"OnMinorErrorDoItemSkip" |
"PROCESSRETURNCODE" |
"PROLOGMINORERRORCOUNT" |
"ProcessReturnCode" |
"PrologMinorErrorCount" |
"SETODBCUNICODEINTERFACE" |
"STRINGGLOBALVARIABLE" |
"STRINGSESSIONVARIABLE" |
"SVALUE" |
"SValue" |
"SetODBCUnicodeInterface" |
"StringGlobalVariable" |
"StringSessionVariable" |
"VALUE_IS_STRING" |
"Value_Is_String" |
"dataminorerrorcount" |
"datasourceasciidecimalseparator" |
"datasourceasciidelimiter" |
"datasourceasciiheaderrecords" |
"datasourceasciiquotecharacter" |
"datasourceasciithousandseparator" |
"datasourcecubeview" |
"datasourcedimensionsubset" |
"datasourcenameforclient" |
"datasourcenameforserver" |
"datasourceodbocatalog" |
"datasourceodboconnectionstring" |
"datasourceodbocubename" |
"datasourceodbohierarchyname" |
"datasourceodbolocation" |
"datasourceodboprovider" |
"datasourceodbosapclientid" |
"datasourceodbosapclientlanguage" |
"datasourcepassword" |
"datasourcequery" |
"datasourcesapusingroleauths" |
"datasourcesapusingtexts" |
"datasourcetype" |
"datasourceusername" |
"getprocesserrorfiledirectory" |
"getprocesserrorfilename" |
"index" |
"index" |
"metadataminorerrorcount" |
"minorerrorlogmax" |
"numericglobalvariable" |
"numericsessionvariable" |
"nvalue" |
"onminorerrordoitemskip" |
"processreturncode" |
"prologminorerrorcount" |
"setodbcunicodeinterface" |
"stringglobalvariable" |
"stringsessionvariable" |
"svalue" |
"value_is_string"		{ addToken(Token.RESERVED_WORD_2); }

	/* Data types */
	/* No data types */

	/* Functions */
	"AddCubeDependency" |
"AddInfoCubeRestriction" |
"AsciiDelete" |
"AsciiOutput" |
"AsciiOutputOpen" |
"AssignClientPassword" |
"AssociateCAMIDToGroup" |
"CGAddPromptValues" |
"CGPromptGetNextMember" |
"CGPromptSize" |
"CellIncrementN" |
"ChoreAttrDelete" |
"ChoreAttrInsert" |
"ChoreAttrN" |
"ChoreAttrNL" |
"ChoreAttrPutN" |
"ChoreAttrPutS" |
"ChoreAttrS" |
"ChoreAttrSL" |
"ChoreError" |
"ChoreQuit" |
"ChoreRollBack" |
"ConsolidatedAvg" |
"ConsolidatedCount" |
"ConsolidatedCountUnique" |
"ConsolidatedMax" |
"ConsolidatedMin" |
"CreateHierarchyByAttribute" |
"CubeAttrDelete" |
"CubeAttrInsert" |
"CubeAttrN" |
"CubeAttrNL" |
"CubeAttrPutN" |
"CubeAttrPutS" |
"CubeAttrS" |
"CubeAttrSL" |
"CubeClearData" |
"CubeDRAcquire" |
"CubeDRGet" |
"CubeDRGetConflicts" |
"CubeDRRelease" |
"CubeDRReleaseAll" |
"CubeDimensionCountGet" |
"CubeExists" |
"CubeLockOverride" |
"CubeProcReduceDims" |
"CubeRuleAppend" |
"CubeRuleDestroy" |
"CubeRuleGet" |
"CubeRuleIsValid" |
"CubeRuleRefresh" |
"CubeRuleSet" |
"CubeSaveData" |
"CubeTimeLastUpdated" |
"DataSpread" |
"DeleteAllPersistentFeeders" |
"DimensionAttrDelete" |
"DimensionAttrInsert" |
"DimensionAttrN" |
"DimensionAttrNL" |
"DimensionAttrPutN" |
"DimensionAttrPutS" |
"DimensionAttrS" |
"DimensionAttrSL" |
"DimensionElementComponentAddDirect" |
"DimensionElementComponentDeleteDirect" |
"DimensionElementDeleteDirect" |
"DimensionElementExists" |
"DimensionElementInsertDirect" |
"DimensionExists" |
"DimensionHierarchyCreate" |
"DimensionTimeLastUpdated" |
"DimensionTopElementInsertDirect" |
"DimensionUpdateDirect" |
"DisableBulkLoadMode" |
"DisableMTQViewConstruct" |
"ElementAttrDelete" |
"ElementAttrInsert" |
"ElementAttrN" |
"ElementAttrNL" |
"ElementAttrPutN" |
"ElementAttrPutS" |
"ElementAttrS" |
"ElementAttrSL" |
"ElementComponent" |
"ElementComponentCount" |
"ElementCount" |
"ElementFirst" |
"ElementIndex" |
"ElementIsAncestor" |
"ElementIsComponent" |
"ElementIsParent" |
"ElementLevel" |
"ElementName" |
"ElementNext" |
"ElementParent" |
"ElementParentCount" |
"ElementType" |
"ElementWeight" |
"EnableBulkLoadMode" |
"EnablePersonalWorkspace" |
"ExecuteJavaN" |
"ExecuteJavaS" |
"ExecuteProcess" |
"FILE_OPEN_APPEND" |
"FILE_OPEN_SHARED" |
"ForceSkipcheck" |
"FormatDate" |
"GetProcessErrorFileDirectory" |
"GetProcessErrorFilename" |
"GetProcessName" |
"GetUseActiveSandboxProperty" |
"Hierarchy" |
"HierarchyAttrN" |
"HierarchyAttrNL" |
"HierarchyAttrPutN" |
"HierarchyAttrPutS" |
"HierarchyAttrS" |
"HierarchyAttrSL" |
"HierarchyDeleteAllElements" |
"HierarchyDestroy" |
"HierarchyElementComponentAdd" |
"HierarchyElementComponentAddDirect" |
"HierarchyElementComponentDelete" |
"HierarchyElementComponentDeleteDirect" |
"HierarchyElementDelete" |
"HierarchyElementDeleteDirect" |
"HierarchyElementExists" |
"HierarchyElementInsert" |
"HierarchyElementInsertDirect" |
"HierarchyElementPrincipalName" |
"HierarchyElementSecurityGet" |
"HierarchyElementSecurityPut" |
"HierarchySortOrder" |
"HierarchySubsetAliasSet" |
"HierarchySubsetAttrDelete" |
"HierarchySubsetAttrInsert" |
"HierarchySubsetAttrN" |
"HierarchySubsetAttrNL" |
"HierarchySubsetAttrPutN" |
"HierarchySubsetAttrPutS" |
"HierarchySubsetAttrS" |
"HierarchySubsetAttrSL" |
"HierarchySubsetCreate" |
"HierarchySubsetDeleteAllElements" |
"HierarchySubsetDestroy" |
"HierarchySubsetElementDelete" |
"HierarchySubsetElementExists" |
"HierarchySubsetElementGetIndex" |
"HierarchySubsetElementInsert" |
"HierarchySubsetExists" |
"HierarchySubsetGetElementName" |
"HierarchySubsetGetSize" |
"HierarchySubsetIsAllSet" |
"HierarchySubsetMdxGet" |
"HierarchySubsetMdxSet" |
"HierarchyTimeLastUpdated" |
"HierarchyTopElementInsert" |
"HierarchyTopElementInsertDirect" |
"HierarchyUpdateDirect" |
"IsUndefinedCellValue" |
"LevelCount" |
"LockBreather" |
"LogOutput" |
"NewDateFormatter" |
"NumericGlobalVariable" |
"NumericSessionVariable" |
"ParseDate" |
"ProcessAttrDelete" |
"ProcessAttrInsert" |
"ProcessAttrN" |
"ProcessAttrNL" |
"ProcessAttrPutN" |
"ProcessAttrPutS" |
"ProcessAttrS" |
"ProcessAttrSL" |
"ProcessError" |
"ProcessExitByBreak" |
"ProcessExitByChoreQuit" |
"ProcessExitByChoreRollback" |
"ProcessExitByProcessRollback" |
"ProcessExitByQuit" |
"ProcessExitMinorError" |
"ProcessExitNormal" |
"ProcessExitOnInit" |
"ProcessExitSeriousError" |
"ProcessExitWithMessage" |
"ProcessRollBack" |
"PublishView" |
"RefreshMdxHierarchy" |
"RemoveCAMIDAssociation" |
"RemoveCAMIDAssociationFromGroup" |
"ServerActiveSandboxGet" |
"ServerActiveSandboxSet" |
"ServerSandboxClone" |
"ServerSandboxCreate" |
"ServerSandboxDiscardAllChanges" |
"ServerSandboxExists" |
"ServerSandboxGet" |
"ServerSandboxListCountGet" |
"ServerSandboxMerge" |
"ServerSandboxesDelete" |
"SetChoreVerboseMessages" |
"SetInputCharacterSet" |
"SetOdbcUnicodeInterface" |
"SetOutputCharacterSet" |
"SetOutputEscapeDoubleQuote" |
"SetUseActiveSandboxProperty" |
"StringGlobalVariable" |
"StringSessionVariable" |
"SubsetAliasSet" |
"SubsetCreateByMDX" |
"SubsetElementExists" |
"SubsetExists" |
"SubsetExpandAboveSet" |
"SubsetFormatStyleSet" |
"SubsetIsAllSet" |
"SubsetMdxGet" |
"SubsetMdxSet" |
"Synchronized" |
"TextOutput" |
"UndefinedCellValue" |
"ViewColumnSuppressZeroesSet" |
"ViewExists" |
"ViewExtractFilterByTitlesSet" |
"ViewExtractSkipCalcsSet" |
"ViewExtractSkipConsolidatedStringsSet" |
"ViewExtractSkipRuleValuesSet" |
"ViewExtractSkipZeroesSet" |
"ViewRowSuppressZeroesSet" |
"ViewSuppressZeroesSet" |
"WildcardFileSearch" |
"abs" |
"acos" |
"addgroup" |
"allowexternalrequests" |
"asin" |
"assignclienttogroup" |
"atan" |
"attrdelete" |
"attrinsert" |
"attrn" |
"attrnl" |
"attrputn" |
"attrputs" |
"attrs" |
"attrsl" |
"batchupdatefinish" |
"batchupdatefinishwait" |
"batchupdatestart" |
"capit" |
"cellgetn" |
"cellgets" |
"cellisupdateable" |
"cellputn" |
"cellputproportionalspread" |
"cellputs" |
"char" |
"code" |
"cos" |
"cubecreate" |
"cubedatareservationacquire" |
"cubedatareservationget" |
"cubedatareservationgetconflicts" |
"cubedatareservationrelease" |
"cubedatareservationreleaseall" |
"cubedestroy" |
"cubegetlogchanges" |
"cubeprocessfeeders" |
"cubesetconnparams" |
"cubesetlogchanges" |
"cubeunload" |
"date" |
"dates" |
"day" |
"dayno" |
"delet" |
"deleteclient" |
"deletegroup" |
"dimensioncreate" |
"dimensiondeleteallelements" |
"dimensiondestroy" |
"dimensionelementcomponentadd" |
"dimensionelementcomponentdelete" |
"dimensionelementdelete" |
"dimensionelementinsert" |
"dimensionelementprincipalname" |
"dimensionsortorder" |
"dimensiontopelementinsert" |
"dimix" |
"dimnm" |
"dimsiz" |
"dnext" |
"dnlev" |
"dtype" |
"elcomp" |
"elcompn" |
"elementsecurityget" |
"elementsecurityput" |
"elisanc" |
"eliscomp" |
"elispar" |
"ellev" |
"elpar" |
"elparn" |
"elweight" |
"executecommand" |
"exp" |
"expand" |
"fileexists" |
"fill" |
"fv" |
"if" |
"insrt" |
"int" |
"isund" |
"itemreject" |
"itemskip" |
"ln" |
"lockoff" |
"lockon" |
"log" |
"long" |
"lower" |
"max" |
"min" |
"mod" |
"month" |
"now" |
"numbertostring" |
"numbertostringex" |
"numbr" |
"odbcclose" |
"odbcopen" |
"odbcopenex" |
"odbcoutput" |
"paymt" |
"processbreak" |
"processquit" |
"pv" |
"rand" |
"removeclientfromgroup" |
"returnviewhandle" |
"round" |
"roundp" |
"ruleloadfromfile" |
"savedataall" |
"scan" |
"securityrefresh" |
"addclient" |
"servershutdown" |
"sign" |
"sin" |
"sleep" |
"sqrt" |
"str" |
"stringtonumber" |
"stringtonumberex" |
"subsetattrdelete" |
"subsetattrinsert" |
"subsetattrn" |
"subsetattrnl" |
"subsetattrputn" |
"subsetattrputs" |
"subsetattrs" |
"subsetattrsl" |
"subsetcreate" |
"subsetdeleteallelements" |
"subsetdestroy" |
"subsetelementdelete" |
"subsetelementgetindex" |
"subsetelementinsert" |
"subsetgetelementname" |
"subsetgetsize" |
"subst" |
"swapaliaswithprincipalname" |
"tabdim" |
"tan" |
"time" |
"timst" |
"timvl" |
"tm1user" |
"today" |
"trim" |
"undef" |
"upper" |
"viewattrdelete" |
"viewattrinsert" |
"viewattrn" |
"viewattrnl" |
"viewattrputn" |
"viewattrputs" |
"viewattrs" |
"viewattrsl" |
"viewcolumndimensionset" |
"viewconstruct" |
"viewcreate" |
"viewdestroy" |
"viewrowdimensionset" |
"viewsetskipcalcs" |
"viewsetskiprulevalues" |
"viewsetskipzeroes" |
"viewsubsetassign" |
"viewtitledimensionset" |
"viewtitleelementset" |
"viewzeroout" |
"year"		{ addToken(Token.FUNCTION); }

	

	{LineTerminator}				{ addNullToken(); return firstToken; }

	{Identifier}					{ addToken(Token.IDENTIFIER); }

	{WhiteSpace}					{ addToken(Token.WHITESPACE); }

	/* String/Character literals. */
	{CharLiteral}				{ addToken(Token.LITERAL_CHAR); }
{UnclosedCharLiteral}		{ addToken(Token.ERROR_CHAR); addNullToken(); return firstToken; }
{ErrorCharLiteral}			{ addToken(Token.ERROR_CHAR); }
	/* No string literals */

	/* Comment literals. */
	/* No multi-line comments */
	/* No documentation comments */
	{LineCommentBegin}			{ start = zzMarkedPos-1; yybegin(EOL_COMMENT); }

	/* Separators. */
	{Separator}					{ addToken(Token.SEPARATOR); }
	{Separator2}					{ addToken(Token.IDENTIFIER); }

	/* Operators. */
	"%" |
"&" |
"(" |
")" |
"*" |
"+" |
"," |
"-" |
"/" |
";" |
"<" |
"=" |
">" |
"[" |
"\\" |
"]" |
"^" |
"_" |
"|" |
"~"		{ addToken(Token.OPERATOR); }

	/* Numbers */
	{IntegerLiteral}				{ addToken(Token.LITERAL_NUMBER_DECIMAL_INT); }
	/* No hex literals */
	{FloatLiteral}					{ addToken(Token.LITERAL_NUMBER_FLOAT); }
	{ErrorNumberFormat}			{ addToken(Token.ERROR_NUMBER_FORMAT); }

	/* Ended with a line not in a string or comment. */
	<<EOF>>						{ addNullToken(); return firstToken; }

	/* Catch any other (unhandled) characters. */
	.							{ addToken(Token.IDENTIFIER); }

}


/* No char state */

/* No string state */

/* No multi-line comment state */

/* No documentation comment state */

<EOL_COMMENT> {
	[^hwf\n]+				{}
	{URL}					{ int temp=zzStartRead; addToken(start,zzStartRead-1, Token.COMMENT_EOL); addHyperlinkToken(temp,zzMarkedPos-1, Token.COMMENT_EOL); start = zzMarkedPos; }
	[hwf]					{}
	\n						{ addToken(start,zzStartRead-1, Token.COMMENT_EOL); addNullToken(); return firstToken; }
	<<EOF>>					{ addToken(start,zzStartRead-1, Token.COMMENT_EOL); addNullToken(); return firstToken; }
}

